=== src/scripting/CMakeLists.txt ===
if (WL_UNIT_TESTS)
  add_subdirectory(test)
endif (WL_UNIT_TESTS)
