=== debian/changelog ===
widelands (1:18-3build3) xenial; urgency=medium

  * No-change rebuild against libglew1.13

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 11 Nov 2015 20:11:49 +0000

widelands (1:18-3build2) wily; urgency=medium

  * No-change rebuild using GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Aug 2015 10:57:32 +0000

widelands (1:18-3build1) utopic; urgency=medium

  * Rebuild against libsdl-gfx1.2-5.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 May 2014 11:40:46 +0100
