=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package widelands
#
version=3
opts="uversionmangle=s/^/build/,uversionmangle=s/-rc$/~rc/,dversionmangle=s/^1://" \
https://launchpad.net/widelands/+download https://launchpad.net/widelands/.*/widelands-(.*)-src\.tar\.bz2
