=== src/notifications/test/CMakeLists.txt ===
wl_test(notifications_test
  SRCS
    notifications_test.cc
  DEPENDS
    notifications
)
